--- old/usr/src/cmd/fm/fmd/common/fmd_xprt.c	2016-02-15 12:55:59.155223641 -0500
+++ new/usr/src/cmd/fm/fmd/common/fmd_xprt.c	2016-02-15 12:55:59.159036805 -0500
@@ -1158,12 +1158,9 @@
 			if (loc)
 				topo_hdl_strfree(thp, loc);
 		}
-		if (fru)
-			nvlist_free(fru);
-		if (asru)
-			nvlist_free(asru);
-		if (rsrc)
-			nvlist_free(rsrc);
+		nvlist_free(fru);
+		nvlist_free(asru);
+		nvlist_free(rsrc);
 		fmd_fmri_topo_rele(thp);
 		fmd_case_insert_suspect(cp, flt_copy);
 	}
@@ -1327,8 +1324,7 @@
 	    (xip->xi_flags & FMD_XPRT_HC_PRESENT_ONLY)) {
 		if (nelem > 0) {
 			for (i = 0; i < nelem; i++)
-				if (asrua[i])
-					nvlist_free(asrua[i]);
+				nvlist_free(asrua[i]);
 			fmd_free(proxy_asru, sizeof (uint8_t) * nelem);
 			fmd_free(diag_asru, sizeof (uint8_t) * nelem);
 			fmd_free(asrua, sizeof (nvlist_t *) * nelem);
@@ -1344,8 +1340,7 @@
 	    FMD_CASE_UNSOLVED, uuid, code)) == NULL) {
 		if (nelem > 0) {
 			for (i = 0; i < nelem; i++)
-				if (asrua[i])
-					nvlist_free(asrua[i]);
+				nvlist_free(asrua[i]);
 			fmd_free(proxy_asru, sizeof (uint8_t) * nelem);
 			fmd_free(diag_asru, sizeof (uint8_t) * nelem);
 			fmd_free(asrua, sizeof (nvlist_t *) * nelem);
